Index: /LMDZ6/branches/cirrus/libf/phylmd/lmdz_lscp_ini.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/phylmd/lmdz_lscp_ini.F90	(revision 4950)
+++ /LMDZ6/branches/cirrus/libf/phylmd/lmdz_lscp_ini.F90	(revision 4951)
@@ -6,6 +6,6 @@
   !--------------------
  
-  REAL RCPD, RLSTT, RLVTT, RLMLT, RVTMP2, RTT, RD, RG, RPI
-  !$OMP THREADPRIVATE(RCPD, RLSTT, RLVTT, RLMLT, RVTMP2, RTT, RD, RG, RPI)
+  REAL RCPD, RLSTT, RLVTT, RLMLT, RVTMP2, RTT, RD, RV, RG, RPI, EPS_W
+  !$OMP THREADPRIVATE(RCPD, RLSTT, RLVTT, RLMLT, RVTMP2, RTT, RD, RV, RG, RPI, EPS_W)
   
   REAL, SAVE, PROTECTED :: seuil_neb=0.001      ! cloud fraction threshold: a cloud can precipitate when exceeded
@@ -136,6 +136,68 @@
   !$OMP THREADPRIVATE(dist_liq)
 
-  REAL, SAVE, PROTECTED    :: tresh_cl=0.0                  ! cloud fraction threshold for cloud top search
+  REAL, SAVE, PROTECTED  :: tresh_cl=0.0                  ! cloud fraction threshold for cloud top search
   !$OMP THREADPRIVATE(tresh_cl)
+
+  !--Parameters for condensation and ice supersaturation
+  LOGICAL, SAVE, PROTECTED :: ok_external_lognormal=.FALSE.  ! if True, the lognormal condensation scheme is calculated in the lmdz_lscp_condensation routine
+  !$OMP THREADPRIVATE(ok_external_lognormal)
+
+  LOGICAL, SAVE, PROTECTED :: ok_ice_supersat=.FALSE.        ! activates the condensation scheme that allows for ice supersaturation
+  !$OMP THREADPRIVATE(ok_ice_supersat)
+
+  LOGICAL, SAVE, PROTECTED :: ok_unadjusted_clouds=.FALSE.   ! if True, relax the saturation adjustment assumption for ice clouds
+  !$OMP THREADPRIVATE(ok_unadjusted_clouds)
+
+  LOGICAL, SAVE, PROTECTED :: ok_weibull_warm_clouds=.FALSE. ! if True, the weibull condensation scheme replaces the lognormal condensation scheme at positive temperatures
+  !$OMP THREADPRIVATE(ok_weibull_warm_clouds)
+
+  INTEGER, SAVE, PROTECTED :: iflag_cloud_sublim_pdf=3       ! iflag for the distribution of water inside ice clouds
+  !$OMP THREADPRIVATE(iflag_cloud_sublim_pdf)
+
+  REAL, SAVE, PROTECTED :: mu_subl_pdf_lscp=1./3.            ! [-] shape factor of the gamma distribution of water inside ice clouds
+  !$OMP THREADPRIVATE(mu_subl_pdf_lscp)
+  
+  REAL, SAVE, PROTECTED :: beta_pdf_lscp=2.8e-3              ! [] 
+  !$OMP THREADPRIVATE(beta_pdf_lscp)
+  
+  REAL, SAVE, PROTECTED :: temp_thresh_pdf_lscp=188.         ! [K] below this temperature, water vapor is homoegeneously distributed in the clear sky region
+  !$OMP THREADPRIVATE(temp_thresh_pdf_lscp)
+  
+  REAL, SAVE, PROTECTED :: rhlmid_pdf_lscp=57.6              ! [%] 
+  !$OMP THREADPRIVATE(rhlmid_pdf_lscp)
+  
+  REAL, SAVE, PROTECTED :: k0_pdf_lscp=1.75                  ! [-] minimum value of the shape parameter for the weibull law
+  !$OMP THREADPRIVATE(k0_pdf_lscp)
+  
+  REAL, SAVE, PROTECTED :: kappa_pdf_lscp=0.0147             ! [] 
+  !$OMP THREADPRIVATE(kappa_pdf_lscp)
+  
+  REAL, SAVE, PROTECTED :: rhl0_pdf_lscp=81.5                ! [%] 
+  !$OMP THREADPRIVATE(rhl0_pdf_lscp)
+  
+  REAL, SAVE, PROTECTED :: cond_thresh_pdf_lscp=1.E-7        ! [-] 
+  !$OMP THREADPRIVATE(cond_thresh_pdf_lscp)
+  
+  REAL, SAVE, PROTECTED :: a_homofreez=2.349                 ! [-] 
+  !$OMP THREADPRIVATE(a_homofreez)
+  
+  REAL, SAVE, PROTECTED :: b_homofreez=259.                  ! [K] 
+  !$OMP THREADPRIVATE(b_homofreez)
+
+  REAL, SAVE, PROTECTED :: delta_hetfreez=1.                 ! [-] value between 0 and 1 to simulate for heterogeneous freezing.
+  !$OMP THREADPRIVATE(delta_hetfreez)
+  
+  REAL, SAVE, PROTECTED :: coef_mixing_lscp=1e-7             ! [-] 
+  !$OMP THREADPRIVATE(coef_mixing_lscp)
+  
+  REAL, SAVE, PROTECTED :: coef_shear_lscp=0.1               ! [-] 
+  !$OMP THREADPRIVATE(coef_shear_lscp)
+  
+  REAL, SAVE, PROTECTED :: chi_mixing_lscp=1.1               ! [-] 
+  !$OMP THREADPRIVATE(chi_mixing_lscp)
+
+!  REAL, SAVE, PROTECTED :: contrail_cross_section=200000.
+!  !$OMP THREADPRIVATE(contrail_cross_section)
+  !--End of the parameters for condensation and ice supersaturation
 
   !--Parameters for poprecip
@@ -225,18 +287,18 @@
 CONTAINS
 
-SUBROUTINE lscp_ini(dtime,lunout_in,prt_level_in,ok_ice_sursat, iflag_ratqs, fl_cor_ebil_in, RCPD_in, RLSTT_in, RLVTT_in, RLMLT_in, &
-                    RVTMP2_in, RTT_in,RD_in,RG_in,RPI_in)
+SUBROUTINE lscp_ini(dtime,lunout_in,prt_level_in,ok_ice_supersat_in, iflag_ratqs, fl_cor_ebil_in, &
+                    RCPD_in, RLSTT_in, RLVTT_in, RLMLT_in, RVTMP2_in, &
+                    RTT_in, RD_in, RV_in, RG_in, RPI_in, EPS_W_in)
 
 
    USE ioipsl_getin_p_mod, ONLY : getin_p
-   USE ice_sursat_mod, ONLY: ice_sursat_init
    USE lmdz_cloudth_ini, ONLY : cloudth_ini
 
    REAL, INTENT(IN)      :: dtime
    INTEGER, INTENT(IN)   :: lunout_in,prt_level_in,iflag_ratqs,fl_cor_ebil_in
-   LOGICAL, INTENT(IN)   :: ok_ice_sursat
+   LOGICAL, INTENT(IN)   :: ok_ice_supersat_in
 
    REAL, INTENT(IN)      :: RCPD_in, RLSTT_in, RLVTT_in, RLMLT_in
-   REAL, INTENT(IN)      ::  RVTMP2_in, RTT_in, RD_in, RG_in, RPI_in
+   REAL, INTENT(IN)      :: RVTMP2_in, RTT_in, RD_in, RV_in, RG_in, RPI_in, EPS_W_in
    character (len=20) :: modname='lscp_ini_mod'
    character (len=80) :: abort_message
@@ -247,6 +309,9 @@
     fl_cor_ebil=fl_cor_ebil_in
 
+    ok_ice_supersat=ok_ice_supersat_in
+
     RG=RG_in
     RD=RD_in
+    RV=RV_in
     RCPD=RCPD_in
     RLVTT=RLVTT_in
@@ -257,4 +322,5 @@
     RVTMP2=RVTMP2_in
     RPI=RPI_in
+    EPS_W=EPS_W_in
 
 
@@ -297,4 +363,5 @@
     CALL getin_p('tresh_cl',tresh_cl)
     CALL getin_p('iflag_oldbug_fisrtilp',iflag_oldbug_fisrtilp)
+    ! for poprecip
     CALL getin_p('ok_poprecip',ok_poprecip)
     CALL getin_p('ok_corr_vap_evasub',ok_corr_vap_evasub)
@@ -316,4 +383,24 @@
     CALL getin_p('snow_fallspeed_clr',snow_fallspeed_clr)
     CALL getin_p('snow_fallspeed_cld',snow_fallspeed_cld)
+    ! for condensation and ice supersaturation
+    CALL getin_p('ok_external_lognormal',ok_external_lognormal)
+    CALL getin_p('ok_unadjusted_clouds',ok_unadjusted_clouds)
+    CALL getin_p('ok_weibull_warm_clouds',ok_weibull_warm_clouds)
+    CALL getin_p('iflag_cloud_sublim_pdf',iflag_cloud_sublim_pdf)
+    CALL getin_p('mu_subl_pdf_lscp',mu_subl_pdf_lscp)
+    CALL getin_p('beta_pdf_lscp',beta_pdf_lscp)
+    CALL getin_p('temp_thresh_pdf_lscp',temp_thresh_pdf_lscp)
+    CALL getin_p('rhlmid_pdf_lscp',rhlmid_pdf_lscp)
+    CALL getin_p('k0_pdf_lscp',k0_pdf_lscp)
+    CALL getin_p('kappa_pdf_lscp',kappa_pdf_lscp)
+    CALL getin_p('rhl0_pdf_lscp',rhl0_pdf_lscp)
+    CALL getin_p('cond_thresh_pdf_lscp',cond_thresh_pdf_lscp)
+    CALL getin_p('a_homofreez',a_homofreez)
+    CALL getin_p('b_homofreez',b_homofreez)
+    CALL getin_p('delta_hetfreez',delta_hetfreez)
+    CALL getin_p('coef_mixing_lscp',coef_mixing_lscp)
+    CALL getin_p('coef_shear_lscp',coef_shear_lscp)
+    CALL getin_p('chi_mixing_lscp',chi_mixing_lscp)
+    !CALL getin_p('contrail_cross_section',contrail_cross_section)
 
 
@@ -354,4 +441,5 @@
     WRITE(lunout,*) 'lscp_ini, iflag_oldbug_fisrtilp', iflag_oldbug_fisrtilp
     WRITE(lunout,*) 'lscp_ini, fl_cor_ebil', fl_cor_ebil
+    ! for poprecip
     WRITE(lunout,*) 'lscp_ini, ok_poprecip', ok_poprecip
     WRITE(lunout,*) 'lscp_ini, ok_corr_vap_evasub', ok_corr_vap_evasub
@@ -367,4 +455,24 @@
     WRITE(lunout,*) 'lscp_ini, snow_fallspeed_clr:', snow_fallspeed_clr
     WRITE(lunout,*) 'lscp_ini, snow_fallspeed_cld:', snow_fallspeed_cld
+    ! for condensation and ice supersaturation
+    WRITE(lunout,*) 'lscp_ini, ok_external_lognormal:', ok_external_lognormal
+    WRITE(lunout,*) 'lscp_ini, ok_ice_supersat:', ok_ice_supersat
+    WRITE(lunout,*) 'lscp_ini, ok_unadjusted_clouds:', ok_unadjusted_clouds
+    WRITE(lunout,*) 'lscp_ini, ok_weibull_warm_clouds:', ok_weibull_warm_clouds
+    WRITE(lunout,*) 'lscp_ini, iflag_cloud_sublim_pdf:', iflag_cloud_sublim_pdf
+    WRITE(lunout,*) 'lscp_ini, mu_subl_pdf_lscp:', mu_subl_pdf_lscp
+    WRITE(lunout,*) 'lscp_ini, beta_pdf_lscp:', beta_pdf_lscp
+    WRITE(lunout,*) 'lscp_ini, temp_thresh_pdf_lscp:', temp_thresh_pdf_lscp
+    WRITE(lunout,*) 'lscp_ini, rhlmid_pdf_lscp:', rhlmid_pdf_lscp
+    WRITE(lunout,*) 'lscp_ini, k0_pdf_lscp:', k0_pdf_lscp
+    WRITE(lunout,*) 'lscp_ini, kappa_pdf_lscp:', kappa_pdf_lscp
+    WRITE(lunout,*) 'lscp_ini, rhl0_pdf_lscp:', rhl0_pdf_lscp
+    WRITE(lunout,*) 'lscp_ini, a_homofreez:', a_homofreez
+    WRITE(lunout,*) 'lscp_ini, b_homofreez:', b_homofreez
+    WRITE(lunout,*) 'lscp_ini, delta_hetfreez', delta_hetfreez
+    WRITE(lunout,*) 'lscp_ini, coef_mixing_lscp:', coef_mixing_lscp
+    WRITE(lunout,*) 'lscp_ini, coef_shear_lscp:', coef_shear_lscp
+    WRITE(lunout,*) 'lscp_ini, chi_mixing_lscp:', chi_mixing_lscp
+!    WRITE(lunout,*) 'lscp_ini, contrail_cross_section:', contrail_cross_section
 
 
@@ -389,4 +497,21 @@
 
 
+    !--Check flags for condensation and ice supersaturation
+    IF ( ok_external_lognormal .AND. ok_ice_supersat ) THEN
+      abort_message = 'in lscp, ok_external_lognormal=y is incompatible with ok_ice_supersat=y'
+      CALL abort_physic (modname,abort_message,1)
+    ENDIF
+
+    IF ( ok_weibull_warm_clouds .AND. .NOT. ok_ice_supersat ) THEN
+      abort_message = 'in lscp, ok_weibull_warm_clouds=y needs ok_ice_supersat=y'
+      CALL abort_physic (modname,abort_message,1)
+    ENDIF
+
+    IF ( ok_unadjusted_clouds .AND. .NOT. ok_ice_supersat ) THEN
+      abort_message = 'in lscp, ok_unadjusted_clouds=y needs ok_ice_supersat=y'
+      CALL abort_physic (modname,abort_message,1)
+    ENDIF
+
+
     !AA Temporary initialisation
     a_tr_sca(1) = -0.5
@@ -395,6 +520,4 @@
     a_tr_sca(4) = -0.5
     
-    IF (ok_ice_sursat) CALL ice_sursat_init()
-
     CALL cloudth_ini(iflag_cloudth_vert,iflag_ratqs)
 
Index: /LMDZ6/branches/cirrus/libf/phylmd/lmdz_lscp_tools.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/phylmd/lmdz_lscp_tools.F90	(revision 4950)
+++ /LMDZ6/branches/cirrus/libf/phylmd/lmdz_lscp_tools.F90	(revision 4951)
@@ -311,5 +311,6 @@
 !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 
-    use lmdz_lscp_ini, only: iflag_gammasat, t_glace_min, RTT
+    use lmdz_lscp_ini, only: iflag_gammasat, temp_nowater, RTT
+    use lmdz_lscp_ini, only: a_homofreez, b_homofreez, delta_hetfreez
 
     IMPLICIT NONE
@@ -326,7 +327,5 @@
 
     REAL, DIMENSION(klon) ::  qsi,qsl,dqsl,dqsi
-    REAL  fcirrus, fac
-    REAL, PARAMETER :: acirrus=2.349
-    REAL, PARAMETER :: bcirrus=259.0
+    REAL  f_homofreez, fac
 
     INTEGER i
@@ -342,5 +341,5 @@
             dgammasatdt(i)=0.
 
-        ELSEIF ((temp(i) .LT. RTT) .AND. (temp(i) .GT. t_glace_min)) THEN
+        ELSEIF ((temp(i) .LT. RTT) .AND. (temp(i) .GT. temp_nowater)) THEN
             
             IF (iflag_gammasat .GE. 2) THEN          
@@ -355,14 +354,14 @@
 
             IF (iflag_gammasat .GE.1) THEN
-            ! homogeneous freezing of aerosols, according to
-            ! Koop, 2000 and Karcher 2008, QJRMS
-            ! 'Cirrus regime'
-               fcirrus=acirrus-temp(i)/bcirrus
-               IF (fcirrus .GT. qsl(i)/qsi(i)) THEN
+               ! homogeneous freezing of aerosols, according to
+               ! Koop, 2000 and Ren and MacKenzie, 2005 (QJRMS)
+               ! 'Cirrus regime'
+               f_homofreez=a_homofreez-temp(i)/b_homofreez
+               IF (f_homofreez .GT. qsl(i)/qsi(i)) THEN
                   gammasat(i)=qsl(i)/qsi(i)
                   dgammasatdt(i)=(dqsl(i)*qsi(i)-dqsi(i)*qsl(i))/qsi(i)/qsi(i)
                ELSE
-                  gammasat(i)=fcirrus
-                  dgammasatdt(i)=-1.0/bcirrus
+                  gammasat(i)= (1.-delta_hetfreez) + delta_hetfreez * f_homofreez
+                  dgammasatdt(i)=-delta_hetfreez/b_homofreez
                ENDIF
            
@@ -452,4 +451,180 @@
 !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 
+!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+FUNCTION GAMMAINC ( p, x )
+
+!*****************************************************************************80
+!
+!! GAMMAINC computes the regularized lower incomplete Gamma Integral
+!
+!  Modified:
+!
+!    20 January 2008
+!
+!  Author:
+!
+!    Original FORTRAN77 version by B Shea.
+!    FORTRAN90 version by John Burkardt.
+!
+!  Reference:
+!
+!    B Shea,
+!    Algorithm AS 239:
+!    Chi-squared and Incomplete Gamma Integral,
+!    Applied Statistics,
+!    Volume 37, Number 3, 1988, pages 466-473.
+!
+!  Parameters:
+!
+!    Input, real X, P, the parameters of the incomplete
+!    gamma ratio.  0 <= X, and 0 < P.
+!
+!    Output, real GAMMAINC, the value of the incomplete
+!    Gamma integral.
+!
+  IMPLICIT NONE
+
+  REAL A
+  REAL AN
+  REAL ARG
+  REAL B
+  REAL C
+  REAL, PARAMETER :: ELIMIT = - 88.0E+00
+  REAL GAMMAINC
+  REAL, PARAMETER :: OFLO = 1.0E+37
+  REAL P
+  REAL, PARAMETER :: PLIMIT = 1000.0E+00
+  REAL PN1
+  REAL PN2
+  REAL PN3
+  REAL PN4
+  REAL PN5
+  REAL PN6
+  REAL RN
+  REAL, PARAMETER :: TOL = 1.0E-14
+  REAL X
+  REAL, PARAMETER :: XBIG = 1.0E+08
+
+  GAMMAINC = 0.0E+00
+
+  IF ( X == 0.0E+00 ) THEN
+    GAMMAINC = 0.0E+00
+    RETURN
+  END IF
+!
+!  IF P IS LARGE, USE A NORMAL APPROXIMATION.
+!
+  IF ( PLIMIT < P ) THEN
+
+    PN1 = 3.0E+00 * SQRT ( P ) * ( ( X / P )**( 1.0E+00 / 3.0E+00 ) &
+    + 1.0E+00 / ( 9.0E+00 * P ) - 1.0E+00 )
+
+    GAMMAINC = 0.5E+00 * ( 1. + ERF ( PN1 ) )
+    RETURN
+
+  END IF
+!
+!  IF X IS LARGE SET GAMMAD = 1.
+!
+  IF ( XBIG < X ) THEN
+    GAMMAINC = 1.0E+00
+    RETURN
+  END IF
+!
+!  USE PEARSON'S SERIES EXPANSION.
+!  (NOTE THAT P IS NOT LARGE ENOUGH TO FORCE OVERFLOW IN ALOGAM).
+!
+  IF ( X <= 1.0E+00 .OR. X < P ) THEN
+
+    ARG = P * LOG ( X ) - X - LOG_GAMMA ( P + 1.0E+00 )
+    C = 1.0E+00
+    GAMMAINC = 1.0E+00
+    A = P
+
+    DO
+
+      A = A + 1.0E+00
+      C = C * X / A
+      GAMMAINC = GAMMAINC + C
+
+      IF ( C <= TOL ) THEN
+        EXIT
+      END IF
+
+    END DO
+
+    ARG = ARG + LOG ( GAMMAINC )
+
+    IF ( ELIMIT <= ARG ) THEN
+      GAMMAINC = EXP ( ARG )
+    ELSE
+      GAMMAINC = 0.0E+00
+    END IF
+!
+!  USE A CONTINUED FRACTION EXPANSION.
+!
+  ELSE
+
+    ARG = P * LOG ( X ) - X - LOG_GAMMA ( P )
+    A = 1.0E+00 - P
+    B = A + X + 1.0E+00
+    C = 0.0E+00
+    PN1 = 1.0E+00
+    PN2 = X
+    PN3 = X + 1.0E+00
+    PN4 = X * B
+    GAMMAINC = PN3 / PN4
+
+    DO
+
+      A = A + 1.0E+00
+      B = B + 2.0E+00
+      C = C + 1.0E+00
+      AN = A * C
+      PN5 = B * PN3 - AN * PN1
+      PN6 = B * PN4 - AN * PN2
+
+      IF ( PN6 /= 0.0E+00 ) THEN
+
+        RN = PN5 / PN6
+
+        IF ( ABS ( GAMMAINC - RN ) <= MIN ( TOL, TOL * RN ) ) THEN
+          EXIT
+        END IF
+
+        GAMMAINC = RN
+
+      END IF
+
+      PN1 = PN3
+      PN2 = PN4
+      PN3 = PN5
+      PN4 = PN6
+!
+!  RE-SCALE TERMS IN CONTINUED FRACTION IF TERMS ARE LARGE.
+!
+      IF ( OFLO <= ABS ( PN5 ) ) THEN
+        PN1 = PN1 / OFLO
+        PN2 = PN2 / OFLO
+        PN3 = PN3 / OFLO
+        PN4 = PN4 / OFLO
+      END IF
+
+    END DO
+
+    ARG = ARG + LOG ( GAMMAINC )
+
+    IF ( ELIMIT <= ARG ) THEN
+      GAMMAINC = 1.0E+00 - EXP ( ARG )
+    ELSE
+      GAMMAINC = 1.0E+00
+    END IF
+
+  END IF
+
+  RETURN
+END FUNCTION GAMMAINC
+!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+
 END MODULE lmdz_lscp_tools
 
Index: /LMDZ6/branches/cirrus/libf/phylmd/phyetat0_mod.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/phylmd/phyetat0_mod.F90	(revision 4950)
+++ /LMDZ6/branches/cirrus/libf/phylmd/phyetat0_mod.F90	(revision 4951)
@@ -21,5 +21,6 @@
        du_gwd_rando, du_gwd_front, entr_therm, f0, fm_therm, &
        falb_dir, falb_dif, prw_ancien, prlw_ancien, prsw_ancien, prbsw_ancien, &
-       ftsol, pbl_tke, pctsrf, q_ancien, ql_ancien, qs_ancien, qbs_ancien, rneb_ancien, radpas, radsol, rain_fall, ratqs, &
+       ftsol, pbl_tke, pctsrf, q_ancien, ql_ancien, qs_ancien, qbs_ancien, &
+       cf_ancien, rvc_ancien, radpas, radsol, rain_fall, ratqs, &
        rnebcon, rugoro, sig1, snow_fall, bs_fall, solaire_etat0, sollw, sollwdown, &
        solsw, solswfdiff, t_ancien, u_ancien, v_ancien, w01, wake_cstar, wake_deltaq, &
@@ -397,5 +398,4 @@
   ancien_ok=ancien_ok.AND.phyetat0_get(ql_ancien,"QLANCIEN","QLANCIEN",0.)
   ancien_ok=ancien_ok.AND.phyetat0_get(qs_ancien,"QSANCIEN","QSANCIEN",0.)
-  ancien_ok=ancien_ok.AND.phyetat0_get(rneb_ancien,"RNEBANCIEN","RNEBANCIEN",0.)
   ancien_ok=ancien_ok.AND.phyetat0_get(u_ancien,"UANCIEN","UANCIEN",0.)
   ancien_ok=ancien_ok.AND.phyetat0_get(v_ancien,"VANCIEN","VANCIEN",0.)
@@ -412,4 +412,13 @@
      prbsw_ancien(:)=0.
   ENDIF
+  
+  ! cas specifique des variables de la sursaturation par rapport a la glace
+  IF ( ok_ice_supersat ) THEN
+    ancien_ok=ancien_ok.AND.phyetat0_get(cf_ancien,"CFANCIEN","CFANCIEN",0.)
+    ancien_ok=ancien_ok.AND.phyetat0_get(rvc_ancien,"RVCANCIEN","RVCANCIEN",0.)
+  ELSE
+    cf_ancien(:,:)=0.
+    rvc_ancien(:,:)=0.
+  ENDIF
 
   ! Ehouarn: addtional tests to check if t_ancien, q_ancien contain
@@ -419,5 +428,4 @@
        (maxval(ql_ancien).EQ.minval(ql_ancien))     .OR. &
        (maxval(qs_ancien).EQ.minval(qs_ancien))     .OR. &
-       (maxval(rneb_ancien).EQ.minval(rneb_ancien)) .OR. &
        (maxval(prw_ancien).EQ.minval(prw_ancien))   .OR. &
        (maxval(prlw_ancien).EQ.minval(prlw_ancien)) .OR. &
@@ -432,4 +440,11 @@
        ancien_ok=.false.
     ENDIF
+  ENDIF
+
+  IF ( ok_ice_supersat ) THEN
+    IF ( (maxval(cf_ancien).EQ.minval(cf_ancien))     .OR. &
+         (maxval(rvc_ancien).EQ.minval(rvc_ancien)) ) THEN
+       ancien_ok=.false.
+     ENDIF
   ENDIF
 
Index: /LMDZ6/branches/cirrus/libf/phylmd/phyredem.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/phylmd/phyredem.F90	(revision 4950)
+++ /LMDZ6/branches/cirrus/libf/phylmd/phyredem.F90	(revision 4951)
@@ -19,6 +19,7 @@
                                 zval, rugoro, t_ancien, q_ancien,            &
                                 prw_ancien, prlw_ancien, prsw_ancien, prbsw_ancien,      &
-                                ql_ancien, qs_ancien, qbs_ancien, rneb_ancien, u_ancien, &
-                                v_ancien, clwcon, rnebcon, ratqs, pbl_tke,   &
+                                ql_ancien, qs_ancien, qbs_ancien, cf_ancien, &
+                                rvc_ancien, u_ancien, v_ancien,              &
+                                clwcon, rnebcon, ratqs, pbl_tke,             &
                                 wake_delta_pbl_tke, zmax0, f0, sig1, w01,    &
                                 wake_deltat, wake_deltaq, wake_s, awake_s,   &
@@ -252,5 +253,8 @@
     ENDIF
 
-    CALL put_field(pass,"RNEBANCIEN", "RNEBANCIEN", rneb_ancien)
+    IF ( ok_ice_supersat ) THEN
+      CALL put_field(pass,"CFANCIEN", "CFANCIEN", cf_ancien)
+      CALL put_field(pass,"RVCANCIEN", "RVCANCIEN", rvc_ancien)
+    ENDIF
 
     CALL put_field(pass,"PRWANCIEN", "PRWANCIEN", prw_ancien)
Index: /LMDZ6/branches/cirrus/libf/phylmd/phys_local_var_mod.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/phylmd/phys_local_var_mod.F90	(revision 4950)
+++ /LMDZ6/branches/cirrus/libf/phylmd/phys_local_var_mod.F90	(revision 4951)
@@ -18,8 +18,6 @@
       REAL, SAVE, ALLOCATABLE :: u_seri(:,:), v_seri(:,:)
       !$OMP THREADPRIVATE(u_seri, v_seri)
-      REAL, SAVE, ALLOCATABLE :: rneb_seri(:,:)
-      !$OMP THREADPRIVATE(rneb_seri)
-      REAL, SAVE, ALLOCATABLE :: d_rneb_dyn(:,:)
-      !$OMP THREADPRIVATE(d_rneb_dyn)
+      REAL, SAVE, ALLOCATABLE :: cf_seri(:,:), rvc_seri(:,:)
+      !$OMP THREADPRIVATE(cf_seri, rvc_seri)
       REAL, SAVE, ALLOCATABLE :: l_mixmin(:,:,:),l_mix(:,:,:),wprime(:,:,:)
       !$OMP THREADPRIVATE(l_mixmin, l_mix, wprime)
@@ -38,4 +36,6 @@
       REAL, SAVE, ALLOCATABLE :: d_u_dyn(:,:), d_v_dyn(:,:)
       !$OMP THREADPRIVATE(d_u_dyn, d_v_dyn)
+      REAL, SAVE, ALLOCATABLE :: d_cf_dyn(:,:), d_rvc_dyn(:,:)
+      !$OMP THREADPRIVATE(d_cf_dyn, d_rvc_dyn)
       REAL, SAVE, ALLOCATABLE :: d_tr_dyn(:,:,:)
       !$OMP THREADPRIVATE(d_tr_dyn)
@@ -494,44 +494,33 @@
 !$OMP THREADPRIVATE(zn2mout)
 
-      REAL, SAVE, ALLOCATABLE :: qclr(:,:)
-      !$OMP THREADPRIVATE(qclr)
-      REAL, SAVE, ALLOCATABLE :: qcld(:,:)
-      !$OMP THREADPRIVATE(qcld)
-      REAL, SAVE, ALLOCATABLE :: qss(:,:)
-      !$OMP THREADPRIVATE(qss)
-      REAL, SAVE, ALLOCATABLE :: qvc(:,:)
-      !$OMP THREADPRIVATE(qvc)
-      REAL, SAVE, ALLOCATABLE :: rnebclr(:,:)
-      !$OMP THREADPRIVATE(rnebclr)
-      REAL, SAVE, ALLOCATABLE :: rnebss(:,:)
-      !$OMP THREADPRIVATE(rnebss)
-      REAL, SAVE, ALLOCATABLE :: gamma_ss(:,:)
-      !$OMP THREADPRIVATE(gamma_ss)
-      REAL, SAVE, ALLOCATABLE :: N1_ss(:,:)
-      !$OMP THREADPRIVATE(N1_ss)
-      REAL, SAVE, ALLOCATABLE :: N2_ss(:,:)
-      !$OMP THREADPRIVATE(N2_ss)
-      REAL, SAVE, ALLOCATABLE :: drneb_sub(:,:)
-      !$OMP THREADPRIVATE(drneb_sub)
-      REAL, SAVE, ALLOCATABLE :: drneb_con(:,:)
-      !$OMP THREADPRIVATE(drneb_con)
-      REAL, SAVE, ALLOCATABLE :: drneb_tur(:,:)
-      !$OMP THREADPRIVATE(drneb_tur)
-      REAL, SAVE, ALLOCATABLE :: drneb_avi(:,:)
-      !$OMP THREADPRIVATE(drneb_avi)
-      REAL, SAVE, ALLOCATABLE :: zqsatl(:,:)
-      !$OMP THREADPRIVATE(zqsatl)
-      REAL, SAVE, ALLOCATABLE :: zqsats(:,:)
-      !$OMP THREADPRIVATE(zqsats)
-      REAL, SAVE, ALLOCATABLE :: Tcontr(:,:)
-      !$OMP THREADPRIVATE(Tcontr)
-      REAL, SAVE, ALLOCATABLE :: qcontr(:,:)
-      !$OMP THREADPRIVATE(qcontr)
-      REAL, SAVE, ALLOCATABLE :: qcontr2(:,:)
-      !$OMP THREADPRIVATE(qcontr2)
-      REAL, SAVE, ALLOCATABLE :: fcontrN(:,:)
-      !$OMP THREADPRIVATE(fcontrN)
-      REAL, SAVE, ALLOCATABLE :: fcontrP(:,:)
-      !$OMP THREADPRIVATE(fcontrP)
+!-- LSCP - condensation and ice supersaturation variables
+      REAL, SAVE, ALLOCATABLE :: qsub(:,:), qissr(:,:), qcld(:,:)
+      !$OMP THREADPRIVATE(qsub, qissr, qcld)
+      REAL, SAVE, ALLOCATABLE :: subfra(:,:), issrfra(:,:)
+      !$OMP THREADPRIVATE(subfra, issrfra)
+      REAL, SAVE, ALLOCATABLE :: gamma_cond(:,:)
+      !$OMP THREADPRIVATE(gamma_cond)
+      REAL, SAVE, ALLOCATABLE :: ratio_qi_qtot(:,:)
+      !$OMP THREADPRIVATE(ratio_qi_qtot)
+      REAL, SAVE, ALLOCATABLE :: dcf_sub(:,:), dcf_con(:,:), dcf_mix(:,:)
+      !$OMP THREADPRIVATE(dcf_sub, dcf_con, dcf_mix)
+      REAL, SAVE, ALLOCATABLE :: dqi_adj(:,:), dqi_sub(:,:), dqi_con(:,:), dqi_mix(:,:)
+      !$OMP THREADPRIVATE(dqi_adj, dqi_sub, dqi_con, dqi_mix)
+      REAL, SAVE, ALLOCATABLE :: dqvc_adj(:,:), dqvc_sub(:,:), dqvc_con(:,:), dqvc_mix(:,:)
+      !$OMP THREADPRIVATE(dqvc_adj, dqvc_sub, dqvc_con, dqvc_mix)
+      REAL, SAVE, ALLOCATABLE :: qsatliq(:,:), qsatice(:,:)
+      !$OMP THREADPRIVATE(qsatliq, qsatice)
+
+!-- LSCP - aviation and contrails variables
+      REAL, SAVE, ALLOCATABLE :: Tcontr(:,:), qcontr(:,:), qcontr2(:,:)
+      !$OMP THREADPRIVATE(Tcontr, qcontr, qcontr2)
+      REAL, SAVE, ALLOCATABLE :: fcontrN(:,:), fcontrP(:,:)
+      !$OMP THREADPRIVATE(fcontrN, fcontrP)
+      REAL, SAVE, ALLOCATABLE :: dcf_avi(:,:), dqi_avi(:,:), dqvc_avi(:,:)
+      !$OMP THREADPRIVATE(dcf_avi, dqi_avi, dqvc_avi)
+      REAL, SAVE, ALLOCATABLE :: flight_dist(:,:), flight_h2o(:,:)
+      !$OMP THREADPRIVATE(flight_dist, flight_h2o)
+
+!-- LSCP - mixed phase clouds variables
       REAL, SAVE, ALLOCATABLE :: distcltop(:,:)
       !$OMP THREADPRIVATE(distcltop)
@@ -539,6 +528,5 @@
       !$OMP THREADPRIVATE(temp_cltop)
 
-
-!--POPRECIP variables
+!-- LSCP - POPRECIP variables
       REAL, SAVE, ALLOCATABLE :: qraindiag(:,:)
       !$OMP THREADPRIVATE(qraindiag)
@@ -668,4 +656,5 @@
       ALLOCATE(t_seri(klon,klev),q_seri(klon,klev),ql_seri(klon,klev),qs_seri(klon,klev), qbs_seri(klon,klev))
       ALLOCATE(u_seri(klon,klev),v_seri(klon,klev))
+      ALLOCATE(cf_seri(klon,klev),rvc_seri(klon,klev))
       ALLOCATE(l_mixmin(klon,klev+1,nbsrf),l_mix(klon,klev+1,nbsrf),wprime(klon,klev+1,nbsrf))
       ALLOCATE(pbl_eps(klon,klev+1,nbsrf+1))
@@ -678,4 +667,5 @@
       ALLOCATE(d_q_dyn2d(klon),d_ql_dyn2d(klon),d_qs_dyn2d(klon), d_qbs_dyn2d(klon))
       ALLOCATE(d_u_dyn(klon,klev),d_v_dyn(klon,klev))
+      ALLOCATE(d_cf_dyn(klon,klev),d_rvc_dyn(klon,klev))
       ALLOCATE(d_tr_dyn(klon,klev,nbtr))                   !RomP
       ALLOCATE(d_t_con(klon,klev),d_q_con(klon,klev),d_q_con_zmasse(klon,klev))
@@ -954,15 +944,20 @@
       ALLOCATE(zn2mout(klon,6))
 
-! Supersaturation
-      ALLOCATE(rneb_seri(klon,klev))
-      ALLOCATE(d_rneb_dyn(klon,klev))
-      ALLOCATE(qclr(klon,klev), qcld(klon,klev), qss(klon,klev), qvc(klon,klev))
-      ALLOCATE(rnebclr(klon,klev), rnebss(klon,klev), gamma_ss(klon,klev))
-      ALLOCATE(N1_ss(klon,klev), N2_ss(klon,klev))
-      ALLOCATE(drneb_sub(klon,klev), drneb_con(klon,klev), drneb_tur(klon,klev), drneb_avi(klon,klev))
-      ALLOCATE(zqsatl(klon,klev), zqsats(klon,klev))
-      ALLOCATE(Tcontr(klon,klev), qcontr(klon,klev), qcontr2(klon,klev), fcontrN(klon,klev), fcontrP(klon,klev))
-
-!--POPRECIP variables
+!-- LSCP - condensation and ice supersaturation variables
+      ALLOCATE(qsub(klon,klev), qissr(klon,klev), qcld(klon,klev))
+      ALLOCATE(subfra(klon,klev), issrfra(klon,klev))
+      ALLOCATE(gamma_cond(klon,klev), ratio_qi_qtot(klon,klev))
+      ALLOCATE(dcf_sub(klon,klev), dcf_con(klon,klev), dcf_mix(klon,klev))
+      ALLOCATE(dqi_adj(klon,klev), dqi_sub(klon,klev), dqi_con(klon,klev), dqi_mix(klon,klev))
+      ALLOCATE(dqvc_adj(klon,klev), dqvc_sub(klon,klev), dqvc_con(klon,klev), dqvc_mix(klon,klev))
+      ALLOCATE(qsatliq(klon,klev), qsatice(klon,klev))
+
+!-- LSCP - aviation and contrails variables
+      ALLOCATE(Tcontr(klon,klev), qcontr(klon,klev), qcontr2(klon,klev))
+      ALLOCATE(fcontrN(klon,klev), fcontrP(klon,klev))
+      ALLOCATE(dcf_avi(klon,klev), dqi_avi(klon,klev), dqvc_avi(klon,klev))
+      ALLOCATE(flight_dist(klon,klev), flight_h2o(klon,klev))
+
+!-- LSCP - POPRECIP variables
       ALLOCATE(qraindiag(klon,klev), qsnowdiag(klon,klev))
       ALLOCATE(dqreva(klon,klev), dqssub(klon,klev))
@@ -1022,4 +1017,5 @@
       DEALLOCATE(t_seri,q_seri,ql_seri,qs_seri, qbs_seri)
       DEALLOCATE(u_seri,v_seri)
+      DEALLOCATE(cf_seri,rvc_seri)
       DEALLOCATE(l_mixmin,l_mix,wprime)
       DEALLOCATE(pbl_eps)
@@ -1030,4 +1026,5 @@
       DEALLOCATE(d_q_dyn2d,d_ql_dyn2d,d_qs_dyn2d, d_qbs_dyn2d)
       DEALLOCATE(d_u_dyn,d_v_dyn)
+      DEALLOCATE(d_cf_dyn,d_rvc_dyn)
       DEALLOCATE(d_tr_dyn)                      !RomP
       DEALLOCATE(d_t_con,d_q_con,d_q_con_zmasse)
@@ -1270,15 +1267,20 @@
       DEALLOCATE(zn2mout)
 
-! Supersaturation
-      DEALLOCATE(rneb_seri)
-      DEALLOCATE(d_rneb_dyn)
-      DEALLOCATE(qclr, qcld, qss, qvc)
-      DEALLOCATE(rnebclr, rnebss, gamma_ss)
-      DEALLOCATE(N1_ss, N2_ss)
-      DEALLOCATE(drneb_sub, drneb_con, drneb_tur, drneb_avi)
-      DEALLOCATE(zqsatl, zqsats)
-      DEALLOCATE(Tcontr, qcontr, qcontr2, fcontrN, fcontrP)
-
-!--POPRECIP variables
+!-- LSCP - condensation and ice supersaturation variables
+      DEALLOCATE(qsub, qissr, qcld)
+      DEALLOCATE(subfra, issrfra)
+      DEALLOCATE(gamma_cond, ratio_qi_qtot)
+      DEALLOCATE(dcf_sub, dcf_con, dcf_mix)
+      DEALLOCATE(dqi_adj, dqi_sub, dqi_con, dqi_mix)
+      DEALLOCATE(dqvc_adj, dqvc_sub, dqvc_con, dqvc_mix)
+      DEALLOCATE(qsatliq, qsatice)
+
+!-- LSCP - aviation and contrails variables
+      DEALLOCATE(Tcontr, qcontr, qcontr2)
+      DEALLOCATE(fcontrN, fcontrP)
+      DEALLOCATE(dcf_avi, dqi_avi, dqvc_avi)
+      DEALLOCATE(flight_dist, flight_h2o)
+
+!-- LSCP - POPRECIP variables
       DEALLOCATE(qraindiag, qsnowdiag)
       DEALLOCATE(dqreva, dqssub)
